Codeforces Round 901 (Div. 2)

Jellyfish and Undertale

每个工具对答案的贡献为 \(\min(a-1,x_{i})\),并且答案可能会爆 \(long\),状态好差,WA 两次。

1
2
3
4
5
6
7
8
public static void solve() {
int a = io.nextInt(), b = io.nextInt(), n = io.nextInt();
long ans = b;
for (int i = 0; i < n; i++) {
ans += Math.min(a - 1, io.nextInt());
}
io.println(ans);
}

Jellyfish and Game

数学题。当 \(k\bmod 2=1\) 时,先手会得到 \(\min(0,maxb-mina)\);反之,后手此时必然有最小价值的苹果 \(\min(mina,minb)\),而先手此时会有最大价值的苹果 \(\max(maxa,maxb)\),做一次交换即可。

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
public static void solve() {
int n = io.nextInt(), m = io.nextInt(), k = io.nextInt();

long suma = 0L;
int mina = Integer.MAX_VALUE, maxa = Integer.MIN_VALUE;
for (int i = 0; i < n; i++) {
int x = io.nextInt();
suma += x;
mina = Math.min(mina, x);
maxa = Math.max(maxa, x);
}

int minb = Integer.MAX_VALUE, maxb = Integer.MIN_VALUE;
for (int i = 0; i < m; i++) {
int x = io.nextInt();
minb = Math.min(minb, x);
maxb = Math.max(maxb, x);
}

if (k % 2 == 1) {
io.println(suma + Math.max(0, maxb - mina));
} else {
io.println(suma + Math.max(0, maxb - mina) - Math.max(maxa, maxb) + Math.min(mina, minb));
}
}

Jellyfish and Green Apple

完了,官方解法看不懂,下面是我的解法,就是一直乘二求余,贪心的拆分。

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
public static void solve() {
int n = io.nextInt(), m = io.nextInt();

int x = n % m, y = m / gcd(n, m);
if ((y & (y - 1)) != 0) {
io.println(-1);
return;
}

long ans = 0L;
while (x != 0) {
ans += x;
x *= 2;
x %= m;
}
io.println(ans);
}

private static int gcd(int a, int b) {
if (b == 0) return a;
return gcd(b, a % b);
}

下面是官解,大概懂了。\(\frac{a}{b}\) 表示最终每个人得到的苹果价值的小数部分(可以表示为 \(\sum_{i\in S}\frac{1}{2^{i}}\)),因为 \(b\) 必须是二的幂,所以 \(a\) 中 \(1\) 的个数就表示这个人所需的最小苹果片数(就是集合 \(S\) 中元素的个数),乘以 \(m\) 就表示最后总共的苹果片数,然后减去最开始的 \(n\) 片就是需要进行操作的次数(因为每次操作会增加 \(1\) 片)。(这个题解很详细,提供了另一种视角)

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
public static void solve() {
int n = io.nextInt(), m = io.nextInt();

n %= m;
int x = gcd(n, m), a = n / x, b = m / x;
if ((b & (b - 1)) != 0) {
io.println(-1);
} else {
io.println((long) Integer.bitCount(a) * m - n);
}
}

private static int gcd(int a, int b) {
if (b == 0) return a;
return gcd(b, a % b);
}

Jellyfish and Mex

其实是很简单的动态规划,但就是动不起来啊。定义 \(dp[i]\) 为将 \(MEX\) 变为 \(i\) 需要的最小代价,然后从大到小转移即可。

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
private static final int N = 5001;

public static void solve() {
int n = io.nextInt();
int[] cnt = new int[N];
for (int i = 0; i < n; i++) {
int x = io.nextInt();
if (x < n) cnt[x]++;
}

int mex = 0;
while (cnt[mex] > 0) mex++;
long[] dp = new long[mex + 1];
Arrays.fill(dp, Long.MAX_VALUE);
dp[mex] = 0;
for (int i = mex - 1; i >= 0; i--) {
for (int j = i + 1; j <= mex; j++) {
dp[i] = Math.min(dp[i], dp[j] + (long) (cnt[i] - 1) * j + i);
}
}
io.println(dp[0]);
}

CodeTON Round 6 (Div. 1 + Div. 2, Rated, Prizes!)

MEXanized Array

分类讨论,一开始以为不能有重复,花了很多时间。(菜)

1
2
3
4
5
public static void solve() {
int n = io.nextInt(), k = io.nextInt(), x = io.nextInt();
if (n < k || x < k - 1) io.println(-1);
else io.println((k - 1) * k / 2 + (n - k) * (x == k ? k - 1 : x));
}

Friendly Arrays

又看错题了,其实是道很简单的题。

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
public static void solve() {
int n = io.nextInt(), m = io.nextInt();
int a = 0;
for (int i = 0; i < n; i++) {
a ^= io.nextInt();
}
int b = 0;
for (int i = 0; i < m; i++) {
b |= io.nextInt();
}
int min = a, max = a;
if (n % 2 == 0) {
min = a ^ (a & b);
} else {
max = a | b;
}
io.println(min + " " + max);
}

Colorful Table

一个数可以向外扩展到大于等于它的的数的位置,我们可以按 \(k\) 的大小记录左右端点,然后按照从大到小遍历,来扩展边界,最后计算答案。注意,排除不在数组中的数。

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
public static void solve() {
int n = io.nextInt(), k = io.nextInt();
boolean[] mark = new boolean[k];
int[] l = new int[k], r = new int[k];
Arrays.fill(l, n);
Arrays.fill(r, -1);
for (int i = 0; i < n; i++) {
int a = io.nextInt() - 1;
mark[a] = true;
l[a] = Math.min(l[a], i);
r[a] = i;
}
for (int i = k - 2; i >= 0; i--) {
l[i] = Math.min(l[i], l[i + 1]);
r[i] = Math.max(r[i], r[i + 1]);
}
for (int i = 0; i < k; i++) {
if (!mark[i]) io.print(0 + " ");
else io.print(2 * (r[i] - l[i] + 1) + " ");
}
io.println();
}

Prefix Purchase

又又犯蠢了,题目都没读明白。如果右边有更小的数,那么肯定选更小的数是更优的,可以从右向左遍历,将右边的最小值传递到当前位置。然后就是依次处理每个位置,细节见代码。

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
void solve() {
int n;
cin >> n;
vector<int> c(n);
for (int i = 0; i < n; i++) {
cin >> c[i];
}
int k;
cin >> k;
for (int i = n - 2; i >= 0; i--) {
c[i] = min(c[i], c[i + 1]);
}
int m = k;
for (int i = 0; i < n; i++) {
int x = i == 0 ? c[i] : c[i] - c[i - 1];
if (x != 0) m = min(m, k / x);
k -= x * m;
cout << m << " \n"[i == n - 1];
}
}

Codeforces Round 900 (Div. 3)

How Much Does Daytona Cost?

所有长度为 \(1\) 的子数组,包含的元素必定是众数,所以只需判断 \(k\) 是否存在于数组中。

1
2
3
4
5
6
7
8
9
10
public static void solve() {
int n = io.nextInt(), k = io.nextInt();
boolean ok = false;
for (int i = 0; i < n; i++) {
if (k == io.nextInt()) {
ok = true;
}
}
io.println(ok ? "YES" : "NO");
}

Aleksa and Stack

两个奇数相加得到偶数,两个奇数相乘得到奇数,奇数不会被偶数整除,所以构造一个全是奇数的序列即可。

1
2
3
4
5
6
7
public static void solve() {
int n = io.nextInt();
for (int i = 0; i < n; i++) {
io.print(i * 2 + 1 + " ");
}
io.println();
}

Vasilije in Cacak

只要 \(x\) 在最小值和最大值之间,就总是可以被表示出来。

1
2
3
4
5
6
7
8
public static void solve() {
int n = io.nextInt(), k = io.nextInt();
long x = io.nextLong();
long a = (long) (1 + k) * k / 2;
long b = (long) (n - k + 1 + n) * k / 2;
if (x >= a && x <= b) io.println("YES");
else io.println("NO");
}

Reverse Madness

数组被 \(l\) 和 \(r\) 分段,每一段都是相互独立的,可以单独考虑段内的反转情况。可以发现段内反转总是中心对称的,每个元素是否反转,取决于该元素位置被反转次数的奇偶性,可以用两边向中间求累加和的方式统计,也可以用差分数组。(比赛时我没有统计奇偶性,而是抵消相邻的反转的相同部分)

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
public static void solve() {
int n = io.nextInt(), k = io.nextInt();
char[] s = io.next().toCharArray();
int[] l = new int[k];
for (int i = 0; i < k; i++) {
l[i] = io.nextInt() - 1;
}
int[] r = new int[k];
for (int i = 0; i < k; i++) {
r[i] = io.nextInt() - 1;
}
int q = io.nextInt();
int[] cnt = new int[n];
for (int i = 0; i < q; i++) {
cnt[io.nextInt() - 1]++;
}
for (int i = 0; i < k; i++) {
int sum = 0;
for (int a = l[i]; a <= (l[i] + r[i]) / 2; a++) {
int b = r[i] + l[i] - a;
sum += cnt[a] + cnt[b];
if (sum % 2 == 1) {
char c = s[a];
s[a] = s[b];
s[b] = c;
}
}
}
io.println(new String(s));
}

Iva & Pav

比较简单的做法是,计算每个比特位的前缀和,然后对每个查询二分答案的位置,将二分位置的值和 \(k\) 比较来判断二分的走向。比赛时我是用下面的方法做的,就是没想到二分,其实也可以不用二分,但是没看明白为什么,代码在此

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
public static void solve() {
int n = io.nextInt();
int[] a = new int[n];
for (int i = 0; i < n; i++) {
a[i] = io.nextInt();
}

// next[i][j] 表示 a[i] 的第 j 位等于 0 的下一个位置
int[][] next = new int[n + 1][32];
Arrays.fill(next[n], n);
for (int i = n - 1; i >= 0; i--) {
for (int j = 0; j < 32; j++) {
next[i][j] = next[i + 1][j];
if ((a[i] >> j & 1) == 0) {
next[i][j] = i;
}
}
}

int q = io.nextInt();
while (q-- != 0) {
int l = io.nextInt() - 1, k = io.nextInt();
if (a[l] < k) {
io.print("-1 ");
continue;
}

int lo = l, hi = n - 1;
while (lo <= hi) {
int mid = lo + (hi - lo) / 2;
int cur = 0;
for (int i = 0; i < 32; i++) {
if (next[mid][i] > mid && next[mid][i] == next[l][i]) {
cur |= 1 << i;
}
}
if (cur >= k) lo = mid + 1;
else hi = mid - 1;
}
io.print(hi + 1 + " ");
}
io.println();
}